<?php
final class License extends AppModel
{
    private $license_key = NULL;
    private $public_key = NULL;
	private function load()
	{
		$path_to_phpseclib = VENDORDIR . 'phpseclib' . DS;
		$signature_mode = 'sha256';
		$license_hash = hash_file($signature_mode, MODELDIR . 'license_manager.php');
		$possible_license_hashes = array('b2467b904a950086a280c8fe76ab72e9b252dc1181e80da2e1a28a49bfca924c', 'f5b26b4054b3e32b09e465673edbf9bd0d3253fb5f98b9527428637de67bab29');
		if (!in_array($license_hash, $possible_license_hashes)) {
		}
		$signatures = array($path_to_phpseclib . 'Crypt' . DS . 'AES.php' => array('8cc0f2b61bf99a0cee66cd6a2d5807baa9d00fb5f774a825b6279c332c3df58f', '27586e9f1ab05369d531d5bb710aa419c5f4a42434a409ec7a3e54f212fb06e7'), $path_to_phpseclib . 'Crypt' . DS . 'Rijndael.php' => array('0348b151113b6eb5eb7e11987c42952ad7d83e5c1ff5456ce199ea21c4e7eaee', '8fe5622865040a459dd14185ecef34769961c6886856fb935176230655ff5c7e'), $path_to_phpseclib . 'Crypt' . DS . 'RSA.php' => array('3c264e335730cabd91566a8435d18cd0465149a7b8ce1e5a7ddea78751bc1e5b', 'fb96f9183231c974ac00a8b3876a597171a8c6265ba6817cae9dbb6fcaa7010d'), $path_to_phpseclib . 'Crypt' . DS . 'Hash.php' => array('2d7edbde0f1062b3b6094845275de7081994fffcbffc8f5a4c2922a5608db945', 'f6d237f22caba4b9e9bcf612dc768beb54e29f393233fb008edecbb184d28ed8'), $path_to_phpseclib . 'Math' . DS . 'BigInteger.php' => array('57bb493d13486092bedcf5a35aa1c6452e0c5d758d6d9e525364140d51fc6c87', 'fafa8e242c20d172cf7794de66c88753bde39a86522f16ddd3bc7454450e9851'));
		Loader::loadModels($this, array('LicenseManager' => array($path_to_phpseclib, $signature_mode, $signatures, ROOTWEBDIR), 0 => 'Settings'));
		$license_key = $this->Settings->getSetting('license_key');
		$public_key = $this->Settings->getSetting('license_public_key');
		if ($license_key) {
			$this->license_key = $license_key->value;
		}
		if ($public_key) {
			$this->public_key = $public_key->value;
		}
		$this->setKeys();
	}
	private function setKeys()
	{
	}
	private function unload()
	{
		if (isset($this->LicenseManager)) {
			unset($this->LicenseManager);
		}
		if (isset($this->Settings)) {
			unset($this->Settings);
		}
	}
	public function updateLicenseKey($license_key)
	{
           $this->load();
           $this->public_key = null;
           $this->license_key = 'Blesta-4.2.0-Nulled-By-Jonvi';
           $this->setKeys();
           $this->public_key = 'Blesta-4.2.0-Nulled-By-Jonvi';
           $this->setKeys();
           $this->Settings->setSetting("license_public_key", 'Blesta-4.2.0-Nulled-By-Jonvi');
           $this->Settings->setSetting("license_key", 'Blesta-4.2.0-Nulled-By-Jonvi');
           $this->Settings->setSetting("license_data", 'Blesta-4.2.0-Nulled-By-Jonvi');
           return true;
	}
	public function validate($revalidate = false)
	{
            return true;
	}
	public function fetchLicense()
	{
		try {
			$this->load();
			if ($this->public_key == '') {
				$this->fetchKey();
			}
			$license_data = $this->getLicenseData();
			if ($license_data != '') {
				$this->Settings->setSetting('license_data', $license_data);
			}
			return $license_data;
		} catch (Exception $e) {
		}
		$this->unload();
	}
	public function verify($key)
	{
		if (function_exists('hash_hmac')) {
			try {
				$data = 'bnsa32047@#lsfJS;lk138tAKDHS:Djh!23172907YAKJhrSa;fgh';
				return hash_hmac('sha256', $data, $key);
			} catch (Exception $e) {
			}
		}
        return null;
	}
	public function getLocalData()
	{
		try {
			$this->load();
			$license_data = $this->Settings->getSetting('license_data');
			return $this->processLicenseData($license_data->value);
		} catch (Exception $e) {
		}
		$this->unload();
	}
	private function fetchKey()
	{
	}
	private function getLicenseData()
	{
	}
	private function processLicenseData($license_data)
	{
		$ttl = 1209600;
		$result = $this->LicenseManager->validate($license_data, $ttl);
		$result['comp_allowed'] = 1;
		$result['comp_total'] = 2;
		try {
			if (!isset($this->Companies)) {
				Loader::loadModels($this, array('Companies'));
			}
			$result['comp_allowed'] = 1;
			$result['comp_total'] = $this->Companies->getListCount();
			if (isset($result['addons'])) {
				foreach ($result['addons'] as $addon) {
					if (isset($addon['fields']['type']) && $addon['fields']['type'] == 'company') {
						$result['comp_allowed'] += $addon['qty'];
					}
				}
			}
			if ($result['comp_allowed'] < $result['comp_total']) {
				$result['status'] = 'company_quota';
			}
		} catch (Exception $e) {
		}
		return $result;
	}
	private function setError($status)
	{
		$error = NULL;
		switch ($status) {
			case 'invalid_location':
				$error = 'The license is not valid for the installed location.';
				break;
			case 'suspended':
				$error = 'The license is suspended.';
				break;
			case 'expired':
				$error = 'The license has expired.';
				if (substr($this->license_key, 0, 6) == 'trial-') {
					$error = 'Sorry, a trial has already been issued for this' . ' domain and is no longer valid. To obtain a new ' . 'trial key, please contact sales@blesta.com. ' . 'If you\'d like to purchase a license, please ' . 'visit www.blesta.com.';
				}
				break;
			case 'unknown':
				$error = 'The license key is invalid.';
				if (substr($this->license_key, 0, 6) == 'trial-') {
					$error = 'Sorry, a trial has already been issued for this ' . 'domain and is no longer valid. To obtain a new trial' . ' key, please contact sales@blesta.com. If you\'d like' . ' to purchase a license, please visit www.blesta.com.';
				}
				break;
			case 'company_quota':
				$error = 'The license is not valid for all companies in the system.';
				break;
		}
		$this->Input->setErrors(array());
		if ($error) {
			$this->Input->setErrors(array('status' => array('invalid' => $error)));
		}
	}
}